#!/usr/bin/env python
# encoding=utf-8 (pep 0263)

def del_(x, ys):
    result = []
    for y in ys:
        if x != y:
            result.append(y)
    return result

def del1(x, ys):
    result_head = []
    result_tail = ys
    for y in ys:
        result_tail = result_tail[1:]
        if x == y:
            yield result_head + result_tail
        result_head.append(y)

def insert(x, ys):
    if not ys:
        yield [x]
    else:
        result_head = []
        result_tail = ys
        for y in ys:
            yield result_head + [x] + result_tail
            result_tail = result_tail[1:]
            result_head.append(y)
        yield ys + [x]

def insert1(x, ys):
    return [x] + ys

# demonstracni vypis
if __name__ == "__main__":
    print("Prace se seznamy - del a insert")
    print("-------------------------------\n")
    print("funkce del_(x, ys) smaze vsechny vyskyty prvku x ze seznamu ys")
    print("Vysledek volani del_(1, [1, 2, 1, 1, 2, 3, 1, 1]): %s\n" % \
            del_(1, [1, 2, 1, 1, 2, 3, 1, 1]))

    print("del1(x, ys) smaze vzdy jeden (podle poradi) vyskyt prvku x v seznamu ys")
    print("V_ysledek volani del1(1, [1, 2, 1]): %s\n" % \
            list(del1(1, [1, 2, 1])))

    print("insert(x, ys) vklada postupne na vsechny pozice seznamu ys prvek x")
    print("Vysledek volani insert(4, [2, 3, 1]): %s\n" % \
            list(insert(4, [2, 3, 1])))

    print("insert1(x, ys) vlozi x na zacatek seznamu ys")
    print("Vysledek volani insert1(4, [2, 3, 1]): %s\n" % \
            list(insert1(4, [2, 3, 1])))
