#!/usr/bin/env python
# encoding=utf-8 (pep 0263)

def del1_anyX(xs):
    result_head = []
    result_tail = xs
    for x in xs:
        result_tail = result_tail[1:]
        yield (x, result_head + result_tail)
        result_head.append(x)

def insert(x, ys):
    if not ys:
        yield [x]
    else:
        result_head = []
        result_tail = ys
        for y in ys:
            yield result_head + [x] + result_tail
            result_tail = result_tail[1:]
            result_head.append(y)
        yield ys + [x]

def perm1(xs):
    if not xs:
        yield []
    else:
        for ys in perm1(xs[1:]):
            for zs in insert(xs[0], ys):
                yield zs

def perm2(xs):
    if not xs:
        yield []
    else:
        for y, ys in del1_anyX(xs):
            for zs in perm2(ys):
                yield [y] + zs

def perm3(xs):
    if not xs:
        yield []
    else:
        result_head = []
        result_tail = xs
        for x in xs:
            result_tail = result_tail[1:]
            for ys in perm3(result_head + result_tail):
                yield [x] + ys
            result_head.append(x)

# demonstracni vypis
if __name__ == "__main__":
    print("Prace se seznamy - permutace")
    print("-------------------------------\n")
    print("perm1 napsany pomoci insert")
    print("Vysledek volani perm1([1, 2, 3]): %s\n" % \
            list(perm1([1, 2, 3])))

    print("perm2 napsany pomoci del1_anyX")
    print("Vysledek volani perm2([1, 2, 3]): %s\n" % \
            list(perm2([1, 2, 3])))

    print("perm3 napsany pomoci pruchodu seznamem")
    print("Vysledek volani perm3([1, 2, 3]): %s\n" % \
            list(perm3([1, 2, 3])))
